#define _LARGEFILE_SOURCE
#define _FILE_OFFSET_BITS 64
#define HAVE_STDINT_H

#include <iostream>

#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <time.h>
#include <math.h>
#include <errno.h>

#include <sys/stat.h>
#include <sys/mount.h>

#include <paths.h>
#include <mntent.h>
#include <dirent.h>

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Clock.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_File_Chooser.H>
#include <FL/Fl_Progress.H>
#include <FL/Fl_Multi_Browser.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Menu_Item.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Preferences.H>

#define DOXYGEN 0

extern "C"
{
#include <libburn/libburn.h>
#include <libisofs/libisofs.h>
}

#include "macros.h"

#include "headers.h"

//class launcher : public flburn
//{
	launcher::launcher()
	{
	
	}
	
	launcher::~launcher()
	{
	
	}
	
	void launcher::show_win()
	{
		this->mainwin = new Fl_Window( (int)(screen.w-330)/2 , (int)(screen.h-120)/2 , 330 , 120,"FlBurn" );
		this->mainwin->color(fl_rgb_color(237,236,235));
		this->mainwin->begin();
			
			Fl_Button *disc2iso_button = new Fl_Button(10,10,150,30,"Copy disc to ISO");
			disc2iso_button->callback( disc2iso_button_cb,(void*)this );
			disc2iso_button->labelcolor(fl_rgb_color(255,255,255));
			
			Fl_Button *files2iso_button = new Fl_Button(10,50,150,30,"Make ISO from files");
			files2iso_button->callback( files2iso_button_cb,(void*)this );
			files2iso_button->labelcolor(fl_rgb_color(255,255,255));
			
			Fl_Button *iso2disc_button = new Fl_Button(170,10,150,30,"Burn ISO to disc");
			iso2disc_button->callback( iso2disc_button_cb,(void*)this );
			iso2disc_button->labelcolor(fl_rgb_color(255,255,255));
			
			Fl_Button *files2disc_button = new Fl_Button(170,50,150,30,"Burn files to disc");
			files2disc_button->callback( files2disc_button_cb,(void*)this );
			files2disc_button->labelcolor(fl_rgb_color(255,255,255));
			
			Fl_Button *erase_button = new Fl_Button(10,90,70,20,"Erase");
			erase_button->callback( erase_button_cb,(void*)this );
			erase_button->labelcolor(fl_rgb_color(255,255,255));
			
			Fl_Button *help_button = new Fl_Button(170,90,70,20,"Help");
			help_button->callback( help_button_cb,(void*)this );
			help_button->labelcolor(fl_rgb_color(255,255,255));
			
			Fl_Button *about_button = new Fl_Button(250,90,70,20,"About");
			about_button->callback( about_button_cb,(void*)this );
			about_button->labelcolor(fl_rgb_color(255,255,255));
			
		this->mainwin->end();
		this->mainwin->show();
		this->mainwin->callback(window_close_cb,this);
	}
	
	void launcher::hide_win()
	{
		Fl::delete_widget( (Fl_Widget*)this->mainwin );
	}
	
	void launcher::disc2iso_button_cb(Fl_Widget* w, void* launcher_object)
	{
		launcher *launcher_ob=(launcher*)launcher_object;
		launcher_ob->hide_win();
		flburn_disc2iso.show_win();
	}
	
	void launcher::iso2disc_button_cb(Fl_Widget* w, void* launcher_object)
	{
		launcher *launcher_ob=(launcher*)launcher_object;
		launcher_ob->hide_win();
		flburn_iso2disc.show_win();
	}
	
	void launcher::files2iso_button_cb(Fl_Widget* w, void* launcher_object)
	{
		launcher *launcher_ob=(launcher*)launcher_object;
		launcher_ob->hide_win();
		flburn_files2iso.show_win();
	}
	
	void launcher::files2disc_button_cb(Fl_Widget* wu, void* launcher_object)
	{
		launcher *launcher_ob=(launcher*)launcher_object;
		launcher_ob->hide_win();
		flburn_files2disc.show_win(1,NULL);
	}
	
	void launcher::erase_button_cb(Fl_Widget* w, void* launcher_object)
	{
		launcher *launcher_ob=(launcher*)launcher_object;
		
		short ok = 0;
		
		if(drives.drive_count > 0)
		{
			try_umount();//this will try to unmount cd/dvd drives if any
			for(unsigned int i=0; i<drives.drive_count; i++)
			{
				if(burn_drive_grab(drives.drive_list[i].drive,1))
				{
					if( burn_disc_erasable(drives.drive_list[i].drive) )
					{
						launcher_ob->erase(drives.drive_list[i].drive);
						burn_drive_release(drives.drive_list[i].drive,1);
						ok = 1;
						break;
					}
					else
					{
						burn_drive_release(drives.drive_list[i].drive,0);
					}
				}
			}
		}
		
		if(!ok)
		{
			fl_alert("No erasable disc was found.");
		}
	}
	
	void launcher::help_button_cb(Fl_Widget* w, void* launcher_object)
	{
		fl_message(" Remember the following things: \n\n 1. Don't mount your optical drives before using FlBurn. \n 2. Don't try to copy AudioCD into ISO file. \n 3. DVD+RW discs are overwriteable. Don't try to erase them. \n");
	}
	
	void launcher::about_button_cb(Fl_Widget* w, void* launcher_object)
	{
		char str1[] = " FlBurn ";
		char str2[] = " \n\n Written by Arman Poghosyan (chelovek84) <chelovek84@@yahoo.com> \n Artwork by Levon Ohanyan (Leo) <ohanyanlevon@@gmail.com> \n\n This program is free software; you can redistribute it and/or \n modify it under the terms of the GNU General Public License \n as published by the Free Software Foundation; either version 3 \n of the License, or any later version. \n This program is distributed in the hope that it will be useful, \n but WITHOUT ANY WARRANTY; without even the implied warranty of \n MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the \n GNU General Public License for more details. \n You should have received a copy of the GNU General Public License \n along with this program; if not, write to the Free Software \n Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.";
		char message[ strlen(str1) + strlen(VERSION) + strlen(str2) + 1 ];
		strcpy(message , str1);
		strcat(message , VERSION);
		strcat(message , str2);
		fl_message(message);
	}
	
	void launcher::window_close_cb(Fl_Widget* w, void* launcher_object)
	{
		if(Fl::event()==FL_CLOSE)
		{
			launcher *launcher_ob=(launcher*)launcher_object;
			
			burn_drive_info_free(drives.drive_list);
			std::cout << "Shutting down libburn\n";
			burn_finish();
			std::cout << "Shutting down libisofs\n";
			iso_finish();
			
			//save your preferences
			Fl_Preferences prefs( Fl_Preferences::USER, "flburn.sourceforge.net", "flburn" );
			prefs.set("version",VERSION);
			prefs.set("last_input_dir",launcher_ob->last_input_dir);
			prefs.set("last_output_dir",launcher_ob->last_output_dir);
			prefs.set("last_speed_choice",launcher_ob->last_speed_choice);
			prefs.~Fl_Preferences();
			
			exit(0);
		}
	};
//};
