#define _LARGEFILE_SOURCE
#define _FILE_OFFSET_BITS 64
#define HAVE_STDINT_H

#include <iostream>

#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <time.h>
#include <math.h>
#include <errno.h>

#include <sys/stat.h>
#include <sys/mount.h>

#include <paths.h>
#include <mntent.h>
#include <dirent.h>

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Clock.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_File_Chooser.H>
#include <FL/Fl_Progress.H>
#include <FL/Fl_Multi_Browser.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Menu_Item.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Preferences.H>

#define DOXYGEN 0

extern "C"
{
#include <libburn/libburn.h>
#include <libisofs/libisofs.h>
}

#include "macros.h"

#include "headers.h"

int main(int argc, char **argv)
{
	Fl::background(103,145,198);
	Fl::foreground(84,21,21);
	
	Fl::screen_xywh(screen.x,screen.y,screen.w,screen.h);
	
	Fl_Window *scan_window = new Fl_Window( (int)(screen.w-350)/2 , (int)(screen.h-125)/2 , 350 , 125,"FlBurn" );
	scan_window->color(fl_rgb_color(237,236,235));
	scan_window->begin();
		Fl_Clock *scan_clock=new Fl_Clock(135,10,80,80,"\n Scanning for devices");
		scan_clock->color(fl_rgb_color(255,255,255));
	scan_window->end();
	scan_window->show();
	
	burn_initialize();
	iso_init();
	
	char param_1[]="ALL";
	char param_2[]="ALL";
	char param_3[]="libburner : ";
	burn_msgs_set_severities(param_1, param_2, param_3);
	
	char param_4[]="ALL";
	char param_5[]="ALL";
	char param_6[]="libisofs : ";
	iso_set_msgs_severities(param_4, param_5, param_6);
	
	
	try_umount();//this will try to unmount cd/dvd drives if any
	
	while(burn_drive_scan(&drives.drive_list,&drives.drive_count)==0)
	{
		Fl::check();
		usleep(100002);
	}
	
	Fl::delete_widget( (Fl_Widget*)scan_window );
	
	//Preferences(start)
	Fl_Preferences prefs( Fl_Preferences::USER, "flburn.sourceforge.net", "flburn" );
	
	prefs.get( "last_input_dir" , flburn::last_input_dir , getenv("HOME") , FL_PATH_MAX - 1 );
	prefs.get( "last_output_dir" , flburn::last_output_dir , getenv("HOME") , FL_PATH_MAX - 1 );
	prefs.get( "last_speed_choice" , flburn::last_speed_choice , 0 );
	
	struct stat64 buf_var;
	if( stat64(flburn::last_input_dir,&buf_var)!=0 || !S_ISDIR(buf_var.st_mode) )
	{
		strcpy( flburn::last_input_dir , getenv("HOME") );
	}
	if( stat64(flburn::last_output_dir,&buf_var)!=0 || !S_ISDIR(buf_var.st_mode) )
	{
		strcpy( flburn::last_output_dir , getenv("HOME") );
	}

	prefs.~Fl_Preferences();
	//Preferences(end)
	
	unsigned short show_launcher = 1;
	if(argc == 2)
	{
		unsigned short is_ext_iso = 0;
		
		char* ext = flburn::get_extension( argv[ argc-1 ] );
		if(ext!=NULL)
		{
			if( strcmp(ext,"iso")==0 )
			{
				is_ext_iso = 1;
			}
			free(ext);
		}
		
		if( is_ext_iso )
		{
			char full_iso_path[ strlen( getenv("PWD") ) + 1 + strlen( argv[1] ) + 1 ];
			
			char tmp = argv[1][0];
			if( tmp != '/')
			{
				strcpy( full_iso_path , getenv("PWD") );
				strcat( full_iso_path , "/" );
				strcat( full_iso_path , argv[1] );
			}
			else
			{
				strcpy( full_iso_path , argv[1] );
			}
			
			struct stat64 infile_buf_var;
			if( stat64(full_iso_path,&infile_buf_var)==0 && access(full_iso_path,R_OK)==0 && ( S_ISREG(infile_buf_var.st_mode) || S_ISLNK(infile_buf_var.st_mode) ) )
			{
				show_launcher = 0;
				flburn_iso2disc.show_win();
				flburn_iso2disc.set_iso_file(full_iso_path);
			}
			else
			{
				show_launcher = 0;
				flburn_files2disc.show_win(argc, argv);
			}
		}
		else
		{
			show_launcher = 0;
			flburn_files2disc.show_win(argc, argv);
		}
	}
	else if(argc > 1)
	{
		show_launcher = 0;
		flburn_files2disc.show_win(argc, argv);
	}
	if(show_launcher)
	{
		flburn_launcher.show_win();
	}
	
	return 	Fl::run();
}
