#define _LARGEFILE_SOURCE
#define _FILE_OFFSET_BITS 64
#define HAVE_STDINT_H

#include <iostream>

#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <time.h>
#include <math.h>
#include <errno.h>

#include <sys/stat.h>
#include <sys/mount.h>

#include <paths.h>
#include <mntent.h>
#include <dirent.h>

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Clock.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_File_Chooser.H>
#include <FL/Fl_Progress.H>
#include <FL/Fl_Multi_Browser.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Menu_Item.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Preferences.H>

#define DOXYGEN 0

extern "C"
{
#include <libburn/libburn.h>
#include <libisofs/libisofs.h>
}

#include "macros.h"

#include "headers.h"

int one(const struct dirent *unused)
{
	return 1;
}

void try_umount(void)
{
	int s1,s2,s3,s4;//for sscanf
	
	struct dirent **eps;//for /sys/bus/scsi/devices
	struct dirent **ups;//for each in /sys/bus/scsi/devices
	
	int n = scandir ("/sys/bus/scsi/devices", &eps, one, alphasort);
	if (n >= 0)
	{
		int cnt;
		for (cnt = 0; cnt < n; ++cnt)
		{
			if( sscanf(eps[cnt]->d_name,"%d:%d:%d:%d",&s1,&s2,&s3,&s4)==4 )
			{
				char type_file_path[ strlen("/sys/bus/scsi/devices/") + strlen(eps[cnt]->d_name) + strlen("/type") + 1 ];
				
				strcpy(type_file_path,"/sys/bus/scsi/devices/");
				strcat(type_file_path,eps[cnt]->d_name);
				strcat(type_file_path,"/type");
				
				FILE * pFile = fopen ( type_file_path, "r" );
				
				if(pFile!=NULL)
				{
					int device_type = 0;
					fscanf(pFile,"%d",&device_type);
					fclose(pFile);
					printf("Device type: %d\n",device_type);
					
					if(device_type==5)
					{
						char block_folder_path[ strlen("/sys/bus/scsi/devices/") + strlen(eps[cnt]->d_name) + strlen("/block") + 1 ];
						strcpy(block_folder_path,"/sys/bus/scsi/devices/");
						strcat(block_folder_path,eps[cnt]->d_name);
						strcat(block_folder_path,"/block");
						
						int m = scandir (block_folder_path, &ups, one, alphasort);
						
						if(m > 2)
						{
							char node_path[ strlen("/dev/") + strlen(ups[2]->d_name) + 1 ];
							strcpy(node_path,"/dev/");
							strcat(node_path,ups[2]->d_name);
							printf("%s\n",node_path);
							
							char* tr = canonicalize_file_name(node_path);//possible symbolic link target
							
							FILE * mtabFile = setmntent(_PATH_MOUNTED,"r");
							
							if(mtabFile!=NULL)
							{
								struct mntent *our_mtab;
								
								while(1)
								{
									our_mtab = getmntent (mtabFile);
									if(our_mtab==NULL)
									{
										break;
									}
									else if( strcmp(our_mtab->mnt_fsname,node_path)==0 || (tr!=NULL && strcmp(our_mtab->mnt_fsname,tr)==0) )
									{
										printf("Found: %s \n",our_mtab->mnt_type);
										umount2(our_mtab->mnt_dir,MNT_FORCE);
									}
								}
								endmntent(mtabFile);
							}
							
							if(tr!=NULL)
							{
								printf("Symbolic link's target:  %s\n",tr);
								free(tr);
							}
						}
						
						if(m >= 0)
						{
							int znt;
							for (znt = 0; znt < m; ++znt)
							{
								free(ups[znt]);//free each element
							}
							free(ups);//free the struct itself
						}
					}
				}
				
				puts (type_file_path); 
			}
			free(eps[cnt]);//free each element
		}
		free(eps);//free the struct itself
	}
}
